module     p0_dd_emnebardu_d15h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity0/d15h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d15
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd15h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t15 = dotproduct(k3, qshift)
      t16 = dotproduct(k4, qshift)
      t17 = dotproduct(k1, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t3 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t4 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t5 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb15n20+t1*abb15n31+t15*abb15n29+t16*abb15n29+t17*abb15n3&
         &0+t2*abb15n32+t3*abb15n37+abb15n26*dotproduct(qshift, qshift)+abb15n28&
         &*dotproduct(k6, qshift)+abb15n33*(spvak6k2(1)*qshift(1)-spvak6k2(2)*qs&
         &hift(2)-spvak6k2(3)*qshift(3)-spvak6k2(4)*qshift(4))+abb15n34*dotprodu&
         &ct(k5, qshift)+abb15n36*dotproduct(k2, qshift)+t1*t3*abb15n22+t15*t3*a&
         &bb15n24+t16*t3*abb15n24+t17*t3*abb15n23+t2*t3*abb15n21+t3*t4*abb15n25+&
         &t3*t5*abb15n27)
         return
      end if
      t6 = k1(iv1)
      t7 = k3(iv1)
      t8 = k4(iv1)
      t9 = spvak3k1(iv1)
      t10 = spvak3k4(iv1)
      t11 = spvak5k2(iv1)
      t12 = t11*abb15n24
      t13 = spvak6k1(iv1)
      t14 = spvak6k4(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb15n36+k5(iv1)*abb15n34+k6(iv1)*abb15n28+qshift(&
         &iv1)*abb15n35+spvak6k2(iv1)*abb15n33+t10*abb15n31+t11*abb15n37+t12*t15&
         &+t12*t16+t6*abb15n30+t7*abb15n29+t8*abb15n29+t9*abb15n32+t1*t11*abb15n&
         &22+t10*t3*abb15n22+t11*t17*abb15n23+t11*t2*abb15n21+t11*t4*abb15n25+t1&
         &1*t5*abb15n27+t13*t3*abb15n27+t14*t3*abb15n25+t3*t6*abb15n23+t3*t7*abb&
         &15n24+t3*t8*abb15n24+t3*t9*abb15n21)
         return
      end if
      t1 = spvak5k2(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb15n26+k1(iv2)*t11*abb15n23+k3(iv2)*&
         &t11*abb15n24+k4(iv2)*t11*abb15n24+spvak3k1(iv2)*t11*abb15n21+spvak3k4(&
         &iv2)*t11*abb15n22+spvak6k1(iv2)*t11*abb15n27+spvak6k4(iv2)*t11*abb15n2&
         &5+t1*t10*abb15n22+t1*t13*abb15n27+t1*t14*abb15n25+t1*t6*abb15n23+t1*t7&
         &*abb15n24+t1*t8*abb15n24+t1*t9*abb15n21)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d15:
   subroutine     reconstruct_d15(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_15:
      coeffs%coeffs_15%c0 = derivative(czip)
      coeffs%coeffs_15%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_15%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_15%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_15%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_15%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_15%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_15%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_15%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_15%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_15%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_15%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_15%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_15%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_15%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_15:
   end subroutine reconstruct_d15
!---#] subroutine reconstruct_d15:
end module p0_dd_emnebardu_d15h0l1d
