module     p0_dd_emnebardu_d55h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity0/d55h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d55
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd55h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      real(ki) :: t18
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t16 = dotproduct(qshift, qshift)
      t17 = dotproduct(k1, qshift)
      t18 = dotproduct(k2, qshift)
      t1 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t2 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t16*abb55n17+t17*abb55n22+t18*abb55n25+abb55n13*(spvak2k1(&
         &1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*q&
         &shift(4))+abb55n21*(spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1&
         &k2(3)*qshift(3)-spvak1k2(4)*qshift(4))+t1*t16*abb55n26+t1*t17*abb55n14&
         &+t1*t18*abb55n14+t16*t2*abb55n23+t16*t3*abb55n19+t17*t2*abb55n15+t17*t&
         &3*abb55n16+t18*t2*abb55n15+t18*t3*abb55n16)
         return
      end if
      t4 = k1(iv1)
      t5 = k2(iv1)
      t6 = qshift(iv1)
      t7 = spvak3k1(iv1)
      t8 = t7*abb55n14
      t9 = spvak3k2(iv1)
      t10 = t9*abb55n15
      t11 = spvak3k4(iv1)
      t12 = t11*abb55n16
      if(deg.eq.1) then
         numerator = (spvak1k2(iv1)*abb55n21+spvak2k1(iv1)*abb55n13+t10*t17+t10*&
         &t18+t12*t17+t12*t18+t17*t8+t18*t8+t4*abb55n22+t5*abb55n25+t6*abb55n18+&
         &t1*t4*abb55n14+t1*t5*abb55n14+t1*t6*abb55n27+t11*t16*abb55n19+t16*t7*a&
         &bb55n26+t16*t9*abb55n23+t2*t4*abb55n15+t2*t5*abb55n15+t2*t6*abb55n24+t&
         &3*t4*abb55n16+t3*t5*abb55n16+t3*t6*abb55n20)
         return
      end if
      t16 = d(iv1,iv2)
      t8 = spvak3k1(iv2)
      t10 = spvak3k2(iv2)
      t12 = spvak3k4(iv2)
      t13 = k1(iv2)
      t14 = k2(iv2)
      t15 = qshift(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t16*abb55n17+t1*t16*abb55n26+t16*t2*abb55n23+t16&
         &*t3*abb55n19)+t10*t4*abb55n15+t10*t5*abb55n15+t10*t6*abb55n24+t11*t13*&
         &abb55n16+t11*t14*abb55n16+t11*t15*abb55n20+t12*t4*abb55n16+t12*t5*abb5&
         &5n16+t12*t6*abb55n20+t13*t7*abb55n14+t13*t9*abb55n15+t14*t7*abb55n14+t&
         &14*t9*abb55n15+t15*t7*abb55n27+t15*t9*abb55n24+t4*t8*abb55n14+t5*t8*ab&
         &b55n14+t6*t8*abb55n27)
         return
      end if
      t17 = d(iv2,iv3)
      t18 = d(iv1,iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t16*abb55n26+spvak3k2(iv3)*t16*abb&
         &55n23+spvak3k4(iv3)*t16*abb55n19+t10*t18*abb55n23+t11*t17*abb55n19+t12&
         &*t18*abb55n19+t17*t7*abb55n26+t17*t9*abb55n23+t18*t8*abb55n26))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d55:
   subroutine     reconstruct_d55(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_55:
      coeffs%coeffs_55%c0 = derivative(czip)
      coeffs%coeffs_55%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_55%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_55%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_55%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_55%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_55%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_55%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_55%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_55%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_55%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_55%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_55%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_55%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_55%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_55%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_55%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_55%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_55%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_55%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_55%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_55%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_55%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_55%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_55%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_55%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_55%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_55%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_55%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_55%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_55%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_55%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_55%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_55%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_55%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_55:
   end subroutine reconstruct_d55
!---#] subroutine reconstruct_d55:
end module p0_dd_emnebardu_d55h0l1d
