module     p0_dd_emnebardu_d60h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity0/d60h0l1.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dd_emnebardu_groups, only: &
!           & sign => diagram60_sign, shift => diagram60_shift
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd60h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d60
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d60 = 0.0_ki
      t1 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t2 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t3 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      d60 = (abb60n1*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*sp&
      &vak6k4(4))+abb60n2*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(&
      &4)*spvak5k1(4))+abb60n3*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(&
      &3)-Q(4)*spvak6k1(4))+abb60n5*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+ab&
      &b60n6*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4&
      &))+abb60n7*(Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak&
      &5k2(4))+abb60n8*(Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*&
      &spvak6k2(4))+t1*t3*abb60n13+t1*abb60n10*(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2&
      &)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+t2*t3*abb60n4+t2*abb60n11*(Q(1)*spva&
      &k4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))+t3*abb60n12*(&
      &Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+t3*abb60n9*(Q(1)*k3(1)-Q(2)*&
      &k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+t3*abb60n9*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)&
      &-Q(4)*k4(4)))
      numerator = cmplx(real(d60, ki), aimag(d60), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd60h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d60
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d60 = 0.0_ki
      t1 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t2 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t3 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      d60 = (abb60n1*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*sp&
      &vak6k4(4))+abb60n2*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(&
      &4)*spvak5k1(4))+abb60n3*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(&
      &3)-Q(4)*spvak6k1(4))+abb60n5*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+ab&
      &b60n6*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4&
      &))+abb60n7*(Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak&
      &5k2(4))+abb60n8*(Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*&
      &spvak6k2(4))+t1*t3*abb60n13+t1*abb60n10*(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2&
      &)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+t2*t3*abb60n4+t2*abb60n11*(Q(1)*spva&
      &k4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))+t3*abb60n12*(&
      &Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+t3*abb60n9*(Q(1)*k3(1)-Q(2)*&
      &k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+t3*abb60n9*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)&
      &-Q(4)*k4(4)))

      numerator = cmplx(real(d60, ki), aimag(d60), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dd_emnebardu_d60h0l1
