module     p0_dd_emnebardu_d54h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity1/d54h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d54
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd54h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      t1 = 0.0_ki
      if(deg.eq.0) then
         numerator = t1
         return
      end if
      if(deg.eq.1) then
         numerator = t1
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d54:
   subroutine     reconstruct_d54(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_54:
      coeffs%coeffs_54%c0 = derivative(czip)
      coeffs%coeffs_54%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_54%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_54%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_54%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_54:
   end subroutine reconstruct_d54
!---#] subroutine reconstruct_d54:
end module p0_dd_emnebardu_d54h1l1d
