module     p3_ud_emnebaruu_d3h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p3_ud_emnebaruu/helicity0/d3h0l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d3
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd3h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      real(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb3n33
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak1k2(iv1)
      t6 = spvak3k4(iv1)
      t7 = spvak5k1(iv1)
      t8 = spvak5k2(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb3n59+t2*abb3n42+t3*abb3n60+t4*abb3n61+t5*abb3n51+t6*&
         &abb3n63+t7*abb3n41+t8*abb3n43)
         return
      end if
      t21 = d(iv1,iv2)
      t9 = spvak3k2(iv2)
      t10 = spvak5k2(iv2)
      t11 = spvak6k4(iv2)
      t12 = k1(iv2)
      t13 = spvak3k2(iv1)
      t14 = spvak6k4(iv1)
      t15 = spvak3k4(iv2)
      t16 = spvak5k1(iv2)
      t17 = k2(iv2)
      t18 = k5(iv2)
      t19 = spvak6k2(iv2)
      t20 = spvak6k2(iv1)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*t21*abb3n44+k6(iv2)*t7*abb3n39+spvak1k2(iv2)*t7*a&
         &bb3n49+spvak6k1(iv1)*t15*abb3n62+spvak6k1(iv2)*t6*abb3n62+t1*t10*abb3n&
         &48+t1*t11*abb3n56+t1*t9*abb3n47+t10*t2*abb3n48+t10*t3*abb3n50+t10*t6*a&
         &bb3n57+t10*t7*abb3n37+t11*t2*abb3n56+t11*t3*abb3n54+t11*t7*abb3n38+t12&
         &*t13*abb3n47+t12*t14*abb3n56+t12*t8*abb3n48+t13*t16*abb3n35+t13*t17*ab&
         &b3n47+t13*t18*abb3n45+t14*t16*abb3n38+t14*t17*abb3n56+t14*t18*abb3n54+&
         &t15*t2*abb3n52+t15*t20*abb3n58+t15*t8*abb3n57+t16*t2*abb3n40+t16*t20*a&
         &bb3n36+t16*t4*abb3n39+t16*t5*abb3n49+t16*t8*abb3n37+t17*t6*abb3n52+t17&
         &*t7*abb3n40+t17*t8*abb3n48+t18*t8*abb3n50+t19*t6*abb3n58+t19*t7*abb3n3&
         &6+t2*t9*abb3n47+t3*t9*abb3n45+t7*t9*abb3n35)
         return
      end if
      t22 = d(iv2,iv3)
      t23 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak6k2(iv3)
      t3 = spvak5k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k2(iv3)*t21*abb3n46+spvak5k2(iv3)*t21*abb3&
         &n49+spvak6k4(iv3)*t21*abb3n55+t1*t21*abb3n53+t10*t23*abb3n49+t11*t23*a&
         &bb3n55+t13*t22*abb3n46+t14*t22*abb3n55+t15*t23*abb3n53+t22*t6*abb3n53+&
         &t22*t8*abb3n49+t23*t9*abb3n46)+t1*t16*t20*abb3n34+t1*t19*t7*abb3n34+t1&
         &5*t2*t7*abb3n34+t15*t20*t3*abb3n34+t16*t2*t6*abb3n34+t19*t3*t6*abb3n34&
         &)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d3:
   subroutine     reconstruct_d3(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_3:
      coeffs%coeffs_3%c0 = derivative(czip)
      coeffs%coeffs_3%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_3%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_3%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_3%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_3%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_3%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_3%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_3%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_3%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_3%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_3%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_3%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_3%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_3%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_3%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_3%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_3%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_3%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_3%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_3%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_3%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_3%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_3%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_3%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_3%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_3%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_3%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_3%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_3:
   end subroutine reconstruct_d3
!---#] subroutine reconstruct_d3:
end module p3_ud_emnebaruu_d3h0l1d
