module     p3_ud_emnebaruu_abbrevd55h1
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh1
   implicit none
   private
   complex(ki), public :: abb55n1
   complex(ki), public :: abb55n2
   complex(ki), public :: abb55n3
   complex(ki), public :: abb55n4
   complex(ki), public :: abb55n5
   complex(ki), public :: abb55n6
   complex(ki), public :: abb55n7
   complex(ki), public :: abb55n8
   complex(ki), public :: abb55n9
   complex(ki), public :: abb55n10
   complex(ki), public :: abb55n11
   complex(ki), public :: abb55n12
   complex(ki), public :: rat2d55
   complex(ki), public :: abb55n14
   complex(ki), public :: abb55n15
   complex(ki), public :: abb55n16
   complex(ki), public :: abb55n17
   complex(ki), public :: abb55n18
   complex(ki), public :: abb55n19
   complex(ki), public :: abb55n20
   complex(ki), public :: abb55n21
   complex(ki), public :: abb55n22
   complex(ki), public :: abb55n23
   complex(ki), public :: abb55n24
   complex(ki), public :: abb55n25
   complex(ki), public :: abb55n26
   complex(ki), public :: abb55n27
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   real(ki) :: t9
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t9 = TR*TR
      t3 = t9*t2
      t4 = NC*NC*t1
      t5 = c2*i_
      t6 = NC*t1
      abb55n1 = ((4.0_ki)*(t3/t1+t3/t4-t9*(2.0_ki)*t5/t6))
      t3 = t9*t2*spak1k3*spbk5k4
      abb55n2 = ((8.0_ki)*(t3/t1+t3/t4-t9*(2.0_ki)*t5/t6*spak1k3*spbk5k4))
      t3 = t2*spak1k6
      t7 = t9*t3*spak3k6*spbk4k2*spbk6k5
      t8 = t5*spak1k6
      abb55n3 = ((8.0_ki)*(t9*(2.0_ki)/t6*t8*spak3k6*spbk4k2*spbk6k5-(t7/t4+t7/t&
      &1)))
      t7 = t9*t3*spbk5k2
      abb55n4 = ((8.0_ki)*(t7/t1+t7/t4-t9*(2.0_ki)/t6*t8*spbk5k2))
      t3 = t9*t3*spbk5k4
      t7 = t3/t1
      t3 = t3/t4
      t8 = t9*(2.0_ki)/t6*t8*spbk5k4
      abb55n5 = ((4.0_ki)*(t3+t7-t8))
      abb55n6 = ((8.0_ki)*(t8-(t7+t3)))
      t3 = t9*t2*spak2k3*spbk5k4
      abb55n7 = ((4.0_ki)*(t3/t1+t3/t4-t9*(2.0_ki)*t5/t6*spak2k3*spbk5k4))
      t3 = t2*spak2k6
      t7 = t9*t3*spak3k6*spbk4k2*spbk6k5
      t8 = t5*spak2k6
      abb55n8 = ((4.0_ki)*(t7/t1+t7/t4-t9*(2.0_ki)/t6*t8*spak3k6*spbk4k2*spbk6k5&
      &))
      t3 = t9*t3*spbk5k2
      abb55n9 = ((4.0_ki)*(t9*(2.0_ki)/t6*t8*spbk5k2-(t3/t4+t3/t1)))
      t2 = t2*spak3k6
      t3 = t9*t2*spbk5k4
      t7 = t3/t1
      t3 = t3/t4
      t5 = t5*spak3k6
      t8 = t9*(2.0_ki)*t5/t6*spbk5k4
      abb55n10 = ((8.0_ki)*(t3+t7-t8))
      abb55n11 = ((4.0_ki)*(t8-(t7+t3)))
      t2 = t9*t2*spbk6k5
      abb55n12 = ((4.0_ki)*(t9*(2.0_ki)*t5/t6*spbk6k5-(t2/t4+t2/t1)))
      rat2d55 = 0
      rat2 = rat2 + rat2d55
      abb55n14 = -(abb55n1)
      abb55n15 = abb55n12
      abb55n16 = abb55n10
      abb55n17 = abb55n9
      abb55n18 = abb55n7
      abb55n19 = abb55n6
      abb55n20 = abb55n4
      abb55n21 = abb55n2
      abb55n22 = -(abb55n3)
      abb55n23 = -(abb55n5)
      abb55n24 = (-2.0_ki)*abb55n5
      abb55n25 = -(abb55n8)
      abb55n26 = -(abb55n11)
      abb55n27 = (-2.0_ki)*abb55n11
   end subroutine
end module p3_ud_emnebaruu_abbrevd55h1
