module     p7_dubar_emnebargg_d83h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d83h0l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram83_sign, shift => diagram83_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd83h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d83
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d83 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t3 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d83 = (abb83n1+t1*abb83n13+t10*abb83n7+t2*abb83n14+t3*abb83n15+t4*abb83n16&
      &+t5*abb83n17+t6*abb83n23+t6*t6*abb83n55+t7*abb83n3+t8*abb83n33+t9*abb83n5&
      &+t1*t10*abb83n76+t1*t11*abb83n41+t1*t2*abb83n10+t1*t5*abb83n26+t1*t6*abb8&
      &3n56+t1*t7*abb83n85+t10*t3*abb83n79+t10*t4*abb83n62+t10*t5*abb83n60+t10*t&
      &6*abb83n77+t10*t8*abb83n78+t10*t9*abb83n6+t11*t2*abb83n42+t11*t3*abb83n44&
      &+t11*t4*abb83n47+t11*t5*abb83n45+t11*t6*abb83n46+t11*t8*abb83n40+t11*t9*a&
      &bb83n20+t12*t2*abb83n59+t13*t2*abb83n71+t13*t4*abb83n72+t13*t5*abb83n74+t&
      &13*t6*abb83n73+t2*t3*abb83n11+t2*t5*abb83n52+t2*t6*abb83n9+t2*t7*abb83n61&
      &+t2*t8*abb83n35+t2*t9*abb83n19+t3*t4*abb83n8+t3*t5*abb83n27+t3*t6*abb83n5&
      &7+t3*t7*abb83n86+t3*t8*abb83n34+t3*t9*abb83n12+t4*t8*abb83n36+t5*t6*abb83&
      &n25+t5*t8*abb83n37+t5*t9*abb83n22+t6*t7*abb83n84+t6*t8*abb83n54+t6*t9*abb&
      &83n21+t7*t8*abb83n83+t7*t9*abb83n2+t8*t9*abb83n4+t1*t11*t2*abb83n28+t1*t1&
      &3*t2*abb83n80+t1*t2*t7*abb83n70+t10*t2*t3*abb83n69+t10*t3*t4*abb83n64+t10&
      &*t3*t5*abb83n67+t10*t3*t6*abb83n65+t10*t3*t9*abb83n18+t11*t2*t3*abb83n31+&
      &t11*t2*t6*abb83n29+t11*t2*t8*abb83n30+t11*t2*t9*abb83n58+t12*t2*t3*abb83n&
      &63+t12*t2*t9*abb83n75+t12*t3*t9*abb83n32+t13*t2*t3*abb83n90+t13*t2*t6*abb&
      &83n81+t13*t2*t8*abb83n82+t13*t3*t4*abb83n89+t13*t3*t5*abb83n87+t13*t3*t6*&
      &abb83n88+t14*t2*t3*abb83n43+t14*t3*t4*abb83n48+t14*t3*t5*abb83n50+t14*t3*&
      &t6*abb83n49+t2*t3*t5*abb83n24+t2*t3*t7*abb83n66+t2*t3*t8*abb83n24+t2*t6*t&
      &7*abb83n69+t2*t7*t8*abb83n68+t2*t8*t9*abb83n53+t3*t5*t9*abb83n39+t3*t6*t9&
      &*abb83n38+t3*t9*abb83n51*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5&
      &(3)-Q(4)*spvak2k5(4))+t12*t2*t3*t9*abb83n91)
      numerator = cmplx(real(d83, ki), aimag(d83), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd83h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d83
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d83 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t3 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d83 = (abb83n1+t1*abb83n13+t10*abb83n7+t2*abb83n14+t3*abb83n15+t4*abb83n16&
      &+t5*abb83n17+t6*abb83n23+t6*t6*abb83n55+t7*abb83n3+t8*abb83n33+t9*abb83n5&
      &+t1*t10*abb83n76+t1*t11*abb83n41+t1*t2*abb83n10+t1*t5*abb83n26+t1*t6*abb8&
      &3n56+t1*t7*abb83n85+t10*t3*abb83n79+t10*t4*abb83n62+t10*t5*abb83n60+t10*t&
      &6*abb83n77+t10*t8*abb83n78+t10*t9*abb83n6+t11*t2*abb83n42+t11*t3*abb83n44&
      &+t11*t4*abb83n47+t11*t5*abb83n45+t11*t6*abb83n46+t11*t8*abb83n40+t11*t9*a&
      &bb83n20+t12*t2*abb83n59+t13*t2*abb83n71+t13*t4*abb83n72+t13*t5*abb83n74+t&
      &13*t6*abb83n73+t2*t3*abb83n11+t2*t5*abb83n52+t2*t6*abb83n9+t2*t7*abb83n61&
      &+t2*t8*abb83n35+t2*t9*abb83n19+t3*t4*abb83n8+t3*t5*abb83n27+t3*t6*abb83n5&
      &7+t3*t7*abb83n86+t3*t8*abb83n34+t3*t9*abb83n12+t4*t8*abb83n36+t5*t6*abb83&
      &n25+t5*t8*abb83n37+t5*t9*abb83n22+t6*t7*abb83n84+t6*t8*abb83n54+t6*t9*abb&
      &83n21+t7*t8*abb83n83+t7*t9*abb83n2+t8*t9*abb83n4+t1*t11*t2*abb83n28+t1*t1&
      &3*t2*abb83n80+t1*t2*t7*abb83n70+t10*t2*t3*abb83n69+t10*t3*t4*abb83n64+t10&
      &*t3*t5*abb83n67+t10*t3*t6*abb83n65+t10*t3*t9*abb83n18+t11*t2*t3*abb83n31+&
      &t11*t2*t6*abb83n29+t11*t2*t8*abb83n30+t11*t2*t9*abb83n58+t12*t2*t3*abb83n&
      &63+t12*t2*t9*abb83n75+t12*t3*t9*abb83n32+t13*t2*t3*abb83n90+t13*t2*t6*abb&
      &83n81+t13*t2*t8*abb83n82+t13*t3*t4*abb83n89+t13*t3*t5*abb83n87+t13*t3*t6*&
      &abb83n88+t14*t2*t3*abb83n43+t14*t3*t4*abb83n48+t14*t3*t5*abb83n50+t14*t3*&
      &t6*abb83n49+t2*t3*t5*abb83n24+t2*t3*t7*abb83n66+t2*t3*t8*abb83n24+t2*t6*t&
      &7*abb83n69+t2*t7*t8*abb83n68+t2*t8*t9*abb83n53+t3*t5*t9*abb83n39+t3*t6*t9&
      &*abb83n38+t3*t9*abb83n51*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5&
      &(3)-Q(4)*spvak2k5(4))+t12*t2*t3*t9*abb83n91)

      numerator = cmplx(real(d83, ki), aimag(d83), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d83h0l1
