module     p7_dubar_emnebargg_d95h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d95h0l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d95
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd95h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      real(ki) :: t24
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb95n42
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k3(iv1)
      t4 = k4(iv1)
      t5 = k5(iv1)
      t6 = k6(iv1)
      t7 = spvak2k5(iv1)
      t8 = spvak3k1(iv1)
      t9 = spvak3k4(iv1)
      t10 = spvak5k6(iv1)
      t11 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb95n80+t10*abb95n75+t11*abb95n71+t2*abb95n76+t3*abb95&
         &n79+t4*abb95n79+t5*abb95n72+t6*abb95n81+t7*abb95n70+t8*abb95n77+t9*abb&
         &95n78)
         return
      end if
      t22 = d(iv1,iv2)
      t12 = k2(iv2)
      t13 = k5(iv2)
      t14 = k6(iv2)
      t15 = spvak5k6(iv2)
      t16 = spvak6k5(iv2)
      t17 = k1(iv2)
      t18 = k3(iv2)
      t19 = k4(iv2)
      t20 = spvak3k1(iv2)
      t21 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*t22*abb95n74+spvak2k1(iv1)*t16*abb95n73+spvak2k1(&
         &iv2)*t11*abb95n73+spvak2k4(iv1)*t16*abb95n69+spvak2k4(iv2)*t11*abb95n6&
         &9+spvak2k5(iv2)*t10*abb95n49+spvak2k6(iv1)*t16*abb95n48+spvak2k6(iv2)*&
         &t11*abb95n48+t1*t12*abb95n56+t1*t13*abb95n63+t1*t14*abb95n57+t1*t15*ab&
         &b95n53+t1*t16*abb95n66+t10*t13*abb95n60+t10*t17*abb95n53+t10*t18*abb95&
         &n54+t10*t19*abb95n54+t10*t20*abb95n43+t10*t21*abb95n50+t11*t12*abb95n6&
         &7+t11*t14*abb95n68+t11*t17*abb95n66+t11*t18*abb95n65+t11*t19*abb95n65+&
         &t11*t20*abb95n47+t11*t21*abb95n62+t12*t3*abb95n58+t12*t4*abb95n58+t12*&
         &t8*abb95n44+t12*t9*abb95n51+t13*t3*abb95n64+t13*t4*abb95n64+t13*t8*abb&
         &95n46+t13*t9*abb95n61+t14*t3*abb95n55+t14*t4*abb95n55+t14*t8*abb95n45+&
         &t14*t9*abb95n52+t15*t3*abb95n54+t15*t4*abb95n54+t15*t5*abb95n60+t15*t7&
         &*abb95n49+t15*t8*abb95n43+t15*t9*abb95n50+t16*t2*abb95n67+t16*t3*abb95&
         &n65+t16*t4*abb95n65+t16*t6*abb95n68+t16*t8*abb95n47+t16*t9*abb95n62+t1&
         &7*t2*abb95n56+t17*t5*abb95n63+t17*t6*abb95n57+t18*t2*abb95n58+t18*t5*a&
         &bb95n64+t18*t6*abb95n55+t19*t2*abb95n58+t19*t5*abb95n64+t19*t6*abb95n5&
         &5+t2*t20*abb95n44+t2*t21*abb95n51+t20*t5*abb95n46+t20*t6*abb95n45+t21*&
         &t5*abb95n61+t21*t6*abb95n52)
         return
      end if
      t23 = d(iv2,iv3)
      t24 = d(iv1,iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak5k6(iv3)*t22*abb95n59+spvak6k5(iv3)*t22*abb&
         &95n68+t10*t23*abb95n59+t11*t23*abb95n68+t15*t24*abb95n59+t16*t24*abb95&
         &n68))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d95:
   subroutine     reconstruct_d95(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_95:
      coeffs%coeffs_95%c0 = derivative(czip)
      coeffs%coeffs_95%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_95%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_95%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_95%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_95%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_95%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_95%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_95%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_95%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_95%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_95%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_95%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_95%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_95%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_95%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_95%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_95%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_95%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_95%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_95%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_95%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_95%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_95%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_95%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_95%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_95%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_95%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_95%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_95%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_95%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_95%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_95%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_95%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_95%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_95:
   end subroutine reconstruct_d95
!---#] subroutine reconstruct_d95:
end module p7_dubar_emnebargg_d95h0l1d
