module     p7_dubar_emnebargg_abbrevd3h1
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_globalsh1
   implicit none
   private
   complex(ki), public :: abb3n1
   complex(ki), public :: rat2d3
   complex(ki), public :: abb3n3
   complex(ki), public :: abb3n4
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   real(ki) :: t5
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_dubar_emnebargg_config, only: deltaOS
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_model
      use p7_dubar_emnebargg_color, only: TR
      use p7_dubar_emnebargg_globalsl1, only: epspow
      implicit none
      t1 = TR*c3*i_*spak2k3
      t2 = es234*(es34+wW*mW*i_-mW*mW)*spak5k6*spbk6k5
      t5 = NC*TR
      t3 = t5*c1*i_*spak2k3
      t4 = t5*c2*i_*spak2k3
      abb3n1 = ((4.0_ki)*(t1/t2*spak3k5*spbk4k3*spbk6k1-t1/t2*spak2k5*spbk4k2*sp&
      &bk6k1)+(2.0_ki)*(t3/t2*spak3k5*spbk4k3*spbk6k1+t4/t2*spak3k5*spbk4k3*spbk&
      &6k1-(t4/t2*spak2k5*spbk4k2*spbk6k1+t3/t2*spak2k5*spbk4k2*spbk6k1)))
      rat2d3 = 0
      rat2 = rat2 + rat2d3
      abb3n3 = -(abb3n1)
      abb3n4 = abb3n1
   end subroutine
end module p7_dubar_emnebargg_abbrevd3h1
