module     p7_dubar_emnebargg_d97h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity1/d97h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d97
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd97h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      real(ki) :: t14
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb97n22
         return
      end if
      t1 = k6(iv1)
      t2 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb97n34+t2*abb97n33)
         return
      end if
      t14 = d(iv1,iv2)
      t3 = spvak5k6(iv2)
      t4 = k1(iv1)*t3
      t5 = k1(iv2)*t2
      t6 = k3(iv1)*t3
      t7 = k3(iv2)*t2
      t8 = k4(iv1)*t3
      t9 = k4(iv2)*t2
      t10 = spvak3k1(iv1)*t3
      t11 = spvak3k1(iv2)*t2
      t12 = spvak3k4(iv1)*t3
      t13 = spvak3k4(iv2)*t2
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t14*abb97n32+t2*t3*abb97n24)+t10*abb97n27+t11*ab&
         &b97n27+t12*abb97n28+t13*abb97n28+t4*abb97n29+t5*abb97n29+t6*abb97n30+t&
         &7*abb97n30+t8*abb97n30+t9*abb97n30+k2(iv1)*t3*abb97n31+k2(iv2)*t2*abb9&
         &7n31+k5(iv1)*t3*abb97n26+k5(iv2)*t2*abb97n26+k6(iv2)*t2*abb97n25+spvak&
         &2k6(iv1)*t3*abb97n23+spvak2k6(iv2)*t2*abb97n23+t1*t3*abb97n25)
         return
      end if
      t1 = spvak5k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(d(iv1,iv3)*t3*abb97n39+d(iv2,iv3)*t2*abb97n39+t1&
         &*t10*abb97n41+t1*t11*abb97n41+t1*t12*abb97n38+t1*t13*abb97n38+t1*t14*a&
         &bb97n39+t1*t4*abb97n36+t1*t5*abb97n36+t1*t6*abb97n37+t1*t7*abb97n37+t1&
         &*t8*abb97n37+t1*t9*abb97n37+k1(iv3)*t2*t3*abb97n36+k3(iv3)*t2*t3*abb97&
         &n37+k4(iv3)*t2*t3*abb97n37+spvak2k1(iv1)*t1*t3*abb97n35+spvak2k1(iv2)*&
         &t1*t2*abb97n35+spvak2k1(iv3)*t2*t3*abb97n35+spvak2k4(iv1)*t1*t3*abb97n&
         &40+spvak2k4(iv2)*t1*t2*abb97n40+spvak2k4(iv3)*t2*t3*abb97n40+spvak3k1(&
         &iv3)*t2*t3*abb97n41+spvak3k4(iv3)*t2*t3*abb97n38))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d97:
   subroutine     reconstruct_d97(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_97:
      coeffs%coeffs_97%c0 = derivative(czip)
      coeffs%coeffs_97%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_97%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_97%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_97%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_97%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_97%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_97%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_97%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_97%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_97%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_97%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_97%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_97%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_97%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_97%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_97%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_97%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_97%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_97%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_97%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_97%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_97%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_97%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_97%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_97%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_97%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_97%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_97%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_97%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_97%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_97%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_97%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_97%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_97%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_97:
   end subroutine reconstruct_d97
!---#] subroutine reconstruct_d97:
end module p7_dubar_emnebargg_d97h1l1d
